'use strict';var _copyProperties=require('copyProperties');var _copyProperties2=_interopRequireDefault(_copyProperties);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}var EventValidator={addValidation:function addValidation(emitter,types){var eventTypes=Object.keys(types);var emitterWithValidation=Object.create(emitter);(0,_copyProperties2.default)(emitterWithValidation,{emit:function emit(type,a,b,c,d,e,_){assertAllowsEventType(type,eventTypes);return emitter.emit.call(this,type,a,b,c,d,e,_);}});return emitterWithValidation;}};var recommendationFor=null;var closestTypeFor=null;var typeRecommendationFor=null;var recommendationSort=null;var isCloseEnough=null;var damerauLevenshteinDistance=null;function assertAllowsEventType(type,allowedTypes){if(allowedTypes.indexOf(type)===-1){throw new TypeError(errorMessageFor(type,allowedTypes));}}function errorMessageFor(type,allowedTypes){var message='Unknown event type "'+type+'". ';if(__DEV__){message+=recommendationFor(type,allowedTypes);}message+='Known event types: '+allowedTypes.join(', ')+'.';return message;}if(__DEV__){recommendationFor=function recommendationFor(type,allowedTypes){var closestTypeRecommendation=closestTypeFor(type,allowedTypes);if(isCloseEnough(closestTypeRecommendation,type)){return'Did you mean "'+closestTypeRecommendation.type+'"? ';}else{return'';}};closestTypeFor=function closestTypeFor(type,allowedTypes){var typeRecommendations=allowedTypes.map(typeRecommendationFor.bind(this,type));return typeRecommendations.sort(recommendationSort)[0];};typeRecommendationFor=function typeRecommendationFor(type,recomendedType){return{type:recomendedType,distance:damerauLevenshteinDistance(type,recomendedType)};};recommendationSort=function recommendationSort(recommendationA,recommendationB){if(recommendationA.distance<recommendationB.distance){return-1;}else if(recommendationA.distance>recommendationB.distance){return 1;}else{return 0;}};isCloseEnough=function isCloseEnough(closestType,actualType){return closestType.distance/actualType.length<0.334;};damerauLevenshteinDistance=function damerauLevenshteinDistance(a,b){var i=void 0,j=void 0;var d=[];for(i=0;i<=a.length;i++){d[i]=[i];}for(j=1;j<=b.length;j++){d[0][j]=j;}for(i=1;i<=a.length;i++){for(j=1;j<=b.length;j++){var cost=a.charAt(i-1)===b.charAt(j-1)?0:1;d[i][j]=Math.min(d[i-1][j]+1,d[i][j-1]+1,d[i-1][j-1]+cost);if(i>1&&j>1&&a.charAt(i-1)===b.charAt(j-2)&&a.charAt(i-2)===b.charAt(j-1)){d[i][j]=Math.min(d[i][j],d[i-2][j-2]+cost);}}}return d[a.length][b.length];};}module.exports=EventValidator;